!function(e){if("object"==typeof module&&"object"==typeof module.exports){var t=e(require,exports);void 0!==t&&(module.exports=t)}else"function"==typeof define&&define.amd&&define(["require","exports","./cssScanner","./cssNodes","./cssErrors","../languageFacts/facts","../utils/objects"],e)}((function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Parser=void 0;const r=e("./cssScanner"),s=e("./cssNodes"),i=e("./cssErrors"),n=e("../languageFacts/facts"),a=e("../utils/objects");t.Parser=class{constructor(e=new r.Scanner){this.keyframeRegex=/^@(\-(webkit|ms|moz|o)\-)?keyframes$/i,this.scanner=e,this.token={type:r.TokenType.EOF,offset:-1,len:0,text:""},this.prevToken=void 0}peekIdent(e){return r.TokenType.Ident===this.token.type&&e.length===this.token.text.length&&e===this.token.text.toLowerCase()}peekKeyword(e){return r.TokenType.AtKeyword===this.token.type&&e.length===this.token.text.length&&e===this.token.text.toLowerCase()}peekDelim(e){return r.TokenType.Delim===this.token.type&&e===this.token.text}peek(e){return e===this.token.type}peekOne(...e){return-1!==e.indexOf(this.token.type)}peekRegExp(e,t){return e===this.token.type&&t.test(this.token.text)}hasWhitespace(){return!!this.prevToken&&this.prevToken.offset+this.prevToken.len!==this.token.offset}consumeToken(){this.prevToken=this.token,this.token=this.scanner.scan()}acceptUnicodeRange(){const e=this.scanner.tryScanUnicode();return!!e&&(this.prevToken=e,this.token=this.scanner.scan(),!0)}mark(){return{prev:this.prevToken,curr:this.token,pos:this.scanner.pos()}}restoreAtMark(e){this.prevToken=e.prev,this.token=e.curr,this.scanner.goBackTo(e.pos)}try(e){const t=this.mark(),r=e();return r||(this.restoreAtMark(t),null)}acceptOneKeyword(e){if(r.TokenType.AtKeyword===this.token.type)for(const t of e)if(t.length===this.token.text.length&&t===this.token.text.toLowerCase())return this.consumeToken(),!0;return!1}accept(e){return e===this.token.type&&(this.consumeToken(),!0)}acceptIdent(e){return!!this.peekIdent(e)&&(this.consumeToken(),!0)}acceptKeyword(e){return!!this.peekKeyword(e)&&(this.consumeToken(),!0)}acceptDelim(e){return!!this.peekDelim(e)&&(this.consumeToken(),!0)}acceptRegexp(e){return!!e.test(this.token.text)&&(this.consumeToken(),!0)}_parseRegexp(e){let t=this.createNode(s.NodeType.Identifier);do{}while(this.acceptRegexp(e));return this.finish(t)}acceptUnquotedString(){const e=this.scanner.pos();this.scanner.goBackTo(this.token.offset);const t=this.scanner.scanUnquotedString();return t?(this.token=t,this.consumeToken(),!0):(this.scanner.goBackTo(e),!1)}resync(e,t){for(;;){if(e&&-1!==e.indexOf(this.token.type))return this.consumeToken(),!0;if(t&&-1!==t.indexOf(this.token.type))return!0;if(this.token.type===r.TokenType.EOF)return!1;this.token=this.scanner.scan()}}createNode(e){return new s.Node(this.token.offset,this.token.len,e)}create(e){return new e(this.token.offset,this.token.len)}finish(e,t,r,i){if(!(e instanceof s.Nodelist)&&(t&&this.markError(e,t,r,i),this.prevToken)){const t=this.prevToken.offset+this.prevToken.len;e.length=t>e.offset?t-e.offset:0}return e}markError(e,t,r,i){this.token!==this.lastErrorToken&&(e.addIssue(new s.Marker(e,t,s.Level.Error,void 0,this.token.offset,this.token.len)),this.lastErrorToken=this.token),(r||i)&&this.resync(r,i)}parseStylesheet(e){const t=e.version,r=e.getText();return this.internalParse(r,this._parseStylesheet,((s,i)=>{if(e.version!==t)throw new Error("Underlying model has changed, AST is no longer valid");return r.substr(s,i)}))}internalParse(e,t,r){this.scanner.setSource(e),this.token=this.scanner.scan();const s=t.bind(this)();return s&&(s.textProvider=r||((t,r)=>e.substr(t,r))),s}_parseStylesheet(){const e=this.create(s.Stylesheet);for(;e.addChild(this._parseStylesheetStart()););let t=!1;do{let s=!1;do{s=!1;const n=this._parseStylesheetStatement();for(n&&(e.addChild(n),s=!0,t=!1,this.peek(r.TokenType.EOF)||!this._needsSemicolonAfter(n)||this.accept(r.TokenType.SemiColon)||this.markError(e,i.ParseError.SemiColonExpected));this.accept(r.TokenType.SemiColon)||this.accept(r.TokenType.CDO)||this.accept(r.TokenType.CDC);)s=!0,t=!1}while(s);if(this.peek(r.TokenType.EOF))break;t||(this.peek(r.TokenType.AtKeyword)?this.markError(e,i.ParseError.UnknownAtRule):this.markError(e,i.ParseError.RuleOrSelectorExpected),t=!0),this.consumeToken()}while(!this.peek(r.TokenType.EOF));return this.finish(e)}_parseStylesheetStart(){return this._parseCharset()}_parseStylesheetStatement(e=!1){return this.peek(r.TokenType.AtKeyword)?this._parseStylesheetAtStatement(e):this._parseRuleset(e)}_parseStylesheetAtStatement(e=!1){return this._parseImport()||this._parseMedia(e)||this._parsePage()||this._parseFontFace()||this._parseKeyframe()||this._parseSupports(e)||this._parseLayer(e)||this._parsePropertyAtRule()||this._parseViewPort()||this._parseNamespace()||this._parseDocument()||this._parseContainer(e)||this._parseStartingStyleAtRule(e)||this._parseUnknownAtRule()}_tryParseRuleset(e){const t=this.mark();if(this._parseSelector(e)){for(;this.accept(r.TokenType.Comma)&&this._parseSelector(e););if(this.accept(r.TokenType.CurlyL))return this.restoreAtMark(t),this._parseRuleset(e)}return this.restoreAtMark(t),null}_parseRuleset(e=!1){const t=this.create(s.RuleSet),n=t.getSelectors();if(!n.addChild(this._parseSelector(e)))return null;for(;this.accept(r.TokenType.Comma);)if(!n.addChild(this._parseSelector(e)))return this.finish(t,i.ParseError.SelectorExpected);return this._parseBody(t,this._parseRuleSetDeclaration.bind(this))}_parseRuleSetDeclarationAtStatement(){return this._parseMedia(!0)||this._parseSupports(!0)||this._parseLayer(!0)||this._parseContainer(!0)||this._parseStartingStyleAtRule(!0)||this._parseUnknownAtRule()}_parseRuleSetDeclaration(){return this.peek(r.TokenType.AtKeyword)?this._parseRuleSetDeclarationAtStatement():this.peek(r.TokenType.Ident)?this._tryParseRuleset(!0)||this._parseDeclaration():this._parseRuleset(!0)}_needsSemicolonAfter(e){switch(e.type){case s.NodeType.Keyframe:case s.NodeType.ViewPort:case s.NodeType.Media:case s.NodeType.Ruleset:case s.NodeType.Namespace:case s.NodeType.If:case s.NodeType.For:case s.NodeType.Each:case s.NodeType.While:case s.NodeType.MixinDeclaration:case s.NodeType.FunctionDeclaration:case s.NodeType.MixinContentDeclaration:return!1;case s.NodeType.ExtendsReference:case s.NodeType.MixinContentReference:case s.NodeType.ReturnStatement:case s.NodeType.MediaQuery:case s.NodeType.Debug:case s.NodeType.Import:case s.NodeType.AtApplyRule:case s.NodeType.CustomPropertyDeclaration:return!0;case s.NodeType.VariableDeclaration:return e.needsSemicolon;case s.NodeType.MixinReference:return!e.getContent();case s.NodeType.Declaration:return!e.getNestedProperties()}return!1}_parseDeclarations(e){const t=this.create(s.Declarations);if(!this.accept(r.TokenType.CurlyL))return null;let n=e();for(;t.addChild(n)&&!this.peek(r.TokenType.CurlyR);){if(this._needsSemicolonAfter(n)&&!this.accept(r.TokenType.SemiColon))return this.finish(t,i.ParseError.SemiColonExpected,[r.TokenType.SemiColon,r.TokenType.CurlyR]);for(n&&this.prevToken&&this.prevToken.type===r.TokenType.SemiColon&&(n.semicolonPosition=this.prevToken.offset);this.accept(r.TokenType.SemiColon););n=e()}return this.accept(r.TokenType.CurlyR)?this.finish(t):this.finish(t,i.ParseError.RightCurlyExpected,[r.TokenType.CurlyR,r.TokenType.SemiColon])}_parseBody(e,t){return e.setDeclarations(this._parseDeclarations(t))?this.finish(e):this.finish(e,i.ParseError.LeftCurlyExpected,[r.TokenType.CurlyR,r.TokenType.SemiColon])}_parseSelector(e){const t=this.create(s.Selector);let r=!1;for(e&&(r=t.addChild(this._parseCombinator()));t.addChild(this._parseSimpleSelector());)r=!0,t.addChild(this._parseCombinator());return r?this.finish(t):null}_parseDeclaration(e){const t=this._tryParseCustomPropertyDeclaration(e);if(t)return t;const n=this.create(s.Declaration);return n.setProperty(this._parseProperty())?this.accept(r.TokenType.Colon)?(this.prevToken&&(n.colonPosition=this.prevToken.offset),n.setValue(this._parseExpr())?(n.addChild(this._parsePrio()),this.peek(r.TokenType.SemiColon)&&(n.semicolonPosition=this.token.offset),this.finish(n)):this.finish(n,i.ParseError.PropertyValueExpected)):this.finish(n,i.ParseError.ColonExpected,[r.TokenType.Colon],e||[r.TokenType.SemiColon]):null}_tryParseCustomPropertyDeclaration(e){if(!this.peekRegExp(r.TokenType.Ident,/^--/))return null;const t=this.create(s.CustomPropertyDeclaration);if(!t.setProperty(this._parseProperty()))return null;if(!this.accept(r.TokenType.Colon))return this.finish(t,i.ParseError.ColonExpected,[r.TokenType.Colon]);this.prevToken&&(t.colonPosition=this.prevToken.offset);const n=this.mark();if(this.peek(r.TokenType.CurlyL)){const e=this.create(s.CustomPropertySet),i=this._parseDeclarations(this._parseRuleSetDeclaration.bind(this));if(e.setDeclarations(i)&&!i.isErroneous(!0)&&(e.addChild(this._parsePrio()),this.peek(r.TokenType.SemiColon)))return this.finish(e),t.setPropertySet(e),t.semicolonPosition=this.token.offset,this.finish(t);this.restoreAtMark(n)}const o=this._parseExpr();return o&&!o.isErroneous(!0)&&(this._parsePrio(),this.peekOne(...e||[],r.TokenType.SemiColon,r.TokenType.EOF))?(t.setValue(o),this.peek(r.TokenType.SemiColon)&&(t.semicolonPosition=this.token.offset),this.finish(t)):(this.restoreAtMark(n),t.addChild(this._parseCustomPropertyValue(e)),t.addChild(this._parsePrio()),(0,a.isDefined)(t.colonPosition)&&this.token.offset===t.colonPosition+1?this.finish(t,i.ParseError.PropertyValueExpected):this.finish(t))}_parseCustomPropertyValue(e=[r.TokenType.CurlyR]){const t=this.create(s.Node),n=()=>0===o&&0===h&&0===p,a=()=>-1!==e.indexOf(this.token.type);let o=0,h=0,p=0;e:for(;;){switch(this.token.type){case r.TokenType.SemiColon:case r.TokenType.Exclamation:if(n())break e;break;case r.TokenType.CurlyL:o++;break;case r.TokenType.CurlyR:if(o--,o<0){if(a()&&0===h&&0===p)break e;return this.finish(t,i.ParseError.LeftCurlyExpected)}break;case r.TokenType.ParenthesisL:h++;break;case r.TokenType.ParenthesisR:if(h--,h<0){if(a()&&0===p&&0===o)break e;return this.finish(t,i.ParseError.LeftParenthesisExpected)}break;case r.TokenType.BracketL:p++;break;case r.TokenType.BracketR:if(p--,p<0)return this.finish(t,i.ParseError.LeftSquareBracketExpected);break;case r.TokenType.BadString:break e;case r.TokenType.EOF:let e=i.ParseError.RightCurlyExpected;return p>0?e=i.ParseError.RightSquareBracketExpected:h>0&&(e=i.ParseError.RightParenthesisExpected),this.finish(t,e)}this.consumeToken()}return this.finish(t)}_tryToParseDeclaration(e){const t=this.mark();return this._parseProperty()&&this.accept(r.TokenType.Colon)?(this.restoreAtMark(t),this._parseDeclaration(e)):(this.restoreAtMark(t),null)}_parseProperty(){const e=this.create(s.Property),t=this.mark();return(this.acceptDelim("*")||this.acceptDelim("_"))&&this.hasWhitespace()?(this.restoreAtMark(t),null):e.setIdentifier(this._parsePropertyIdentifier())?this.finish(e):null}_parsePropertyIdentifier(){return this._parseIdent()}_parseCharset(){if(!this.peek(r.TokenType.Charset))return null;const e=this.create(s.Node);return this.consumeToken(),this.accept(r.TokenType.String)?this.accept(r.TokenType.SemiColon)?this.finish(e):this.finish(e,i.ParseError.SemiColonExpected):this.finish(e,i.ParseError.IdentifierExpected)}_parseImport(){if(!this.peekKeyword("@import"))return null;const e=this.create(s.Import);return this.consumeToken(),e.addChild(this._parseURILiteral())||e.addChild(this._parseStringLiteral())?this._completeParseImport(e):this.finish(e,i.ParseError.URIOrStringExpected)}_completeParseImport(e){if(this.acceptIdent("layer")&&this.accept(r.TokenType.ParenthesisL)){if(!e.addChild(this._parseLayerName()))return this.finish(e,i.ParseError.IdentifierExpected,[r.TokenType.SemiColon]);if(!this.accept(r.TokenType.ParenthesisR))return this.finish(e,i.ParseError.RightParenthesisExpected,[r.TokenType.ParenthesisR],[])}return this.acceptIdent("supports")&&this.accept(r.TokenType.ParenthesisL)&&(e.addChild(this._tryToParseDeclaration()||this._parseSupportsCondition()),!this.accept(r.TokenType.ParenthesisR))?this.finish(e,i.ParseError.RightParenthesisExpected,[r.TokenType.ParenthesisR],[]):(this.peek(r.TokenType.SemiColon)||this.peek(r.TokenType.EOF)||e.setMedialist(this._parseMediaQueryList()),this.finish(e))}_parseNamespace(){if(!this.peekKeyword("@namespace"))return null;const e=this.create(s.Namespace);return this.consumeToken(),e.addChild(this._parseURILiteral())||(e.addChild(this._parseIdent()),e.addChild(this._parseURILiteral())||e.addChild(this._parseStringLiteral()))?this.accept(r.TokenType.SemiColon)?this.finish(e):this.finish(e,i.ParseError.SemiColonExpected):this.finish(e,i.ParseError.URIExpected,[r.TokenType.SemiColon])}_parseFontFace(){if(!this.peekKeyword("@font-face"))return null;const e=this.create(s.FontFace);return this.consumeToken(),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))}_parseViewPort(){if(!this.peekKeyword("@-ms-viewport")&&!this.peekKeyword("@-o-viewport")&&!this.peekKeyword("@viewport"))return null;const e=this.create(s.ViewPort);return this.consumeToken(),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))}_parseKeyframe(){if(!this.peekRegExp(r.TokenType.AtKeyword,this.keyframeRegex))return null;const e=this.create(s.Keyframe),t=this.create(s.Node);return this.consumeToken(),e.setKeyword(this.finish(t)),t.matches("@-ms-keyframes")&&this.markError(t,i.ParseError.UnknownKeyword),e.setIdentifier(this._parseKeyframeIdent())?this._parseBody(e,this._parseKeyframeSelector.bind(this)):this.finish(e,i.ParseError.IdentifierExpected,[r.TokenType.CurlyR])}_parseKeyframeIdent(){return this._parseIdent([s.ReferenceType.Keyframe])}_parseKeyframeSelector(){const e=this.create(s.KeyframeSelector);let t=!1;if(e.addChild(this._parseIdent())&&(t=!0),this.accept(r.TokenType.Percentage)&&(t=!0),!t)return null;for(;this.accept(r.TokenType.Comma);)if(t=!1,e.addChild(this._parseIdent())&&(t=!0),this.accept(r.TokenType.Percentage)&&(t=!0),!t)return this.finish(e,i.ParseError.PercentageExpected);return this._parseBody(e,this._parseRuleSetDeclaration.bind(this))}_tryParseKeyframeSelector(){const e=this.create(s.KeyframeSelector),t=this.mark();let i=!1;if(e.addChild(this._parseIdent())&&(i=!0),this.accept(r.TokenType.Percentage)&&(i=!0),!i)return null;for(;this.accept(r.TokenType.Comma);)if(i=!1,e.addChild(this._parseIdent())&&(i=!0),this.accept(r.TokenType.Percentage)&&(i=!0),!i)return this.restoreAtMark(t),null;return this.peek(r.TokenType.CurlyL)?this._parseBody(e,this._parseRuleSetDeclaration.bind(this)):(this.restoreAtMark(t),null)}_parsePropertyAtRule(){if(!this.peekKeyword("@property"))return null;const e=this.create(s.PropertyAtRule);return this.consumeToken(),this.peekRegExp(r.TokenType.Ident,/^--/)&&e.setName(this._parseIdent([s.ReferenceType.Property]))?this._parseBody(e,this._parseDeclaration.bind(this)):this.finish(e,i.ParseError.IdentifierExpected)}_parseStartingStyleAtRule(e=!1){if(!this.peekKeyword("@starting-style"))return null;const t=this.create(s.StartingStyleAtRule);return this.consumeToken(),this._parseBody(t,this._parseStartingStyleDeclaration.bind(this,e))}_parseStartingStyleDeclaration(e=!1){return e?this._tryParseRuleset(!0)||this._tryToParseDeclaration()||this._parseStylesheetStatement(!0):this._parseStylesheetStatement(!1)}_parseLayer(e=!1){if(!this.peekKeyword("@layer"))return null;const t=this.create(s.Layer);this.consumeToken();const n=this._parseLayerNameList();return n&&t.setNames(n),n&&1!==n.getChildren().length||!this.peek(r.TokenType.CurlyL)?this.accept(r.TokenType.SemiColon)?this.finish(t):this.finish(t,i.ParseError.SemiColonExpected):this._parseBody(t,this._parseLayerDeclaration.bind(this,e))}_parseLayerDeclaration(e=!1){return e?this._tryParseRuleset(!0)||this._tryToParseDeclaration()||this._parseStylesheetStatement(!0):this._parseStylesheetStatement(!1)}_parseLayerNameList(){const e=this.createNode(s.NodeType.LayerNameList);if(!e.addChild(this._parseLayerName()))return null;for(;this.accept(r.TokenType.Comma);)if(!e.addChild(this._parseLayerName()))return this.finish(e,i.ParseError.IdentifierExpected);return this.finish(e)}_parseLayerName(){const e=this.createNode(s.NodeType.LayerName);if(!e.addChild(this._parseIdent()))return null;for(;!this.hasWhitespace()&&this.acceptDelim(".");)if(this.hasWhitespace()||!e.addChild(this._parseIdent()))return this.finish(e,i.ParseError.IdentifierExpected);return this.finish(e)}_parseSupports(e=!1){if(!this.peekKeyword("@supports"))return null;const t=this.create(s.Supports);return this.consumeToken(),t.addChild(this._parseSupportsCondition()),this._parseBody(t,this._parseSupportsDeclaration.bind(this,e))}_parseSupportsDeclaration(e=!1){return e?this._tryParseRuleset(!0)||this._tryToParseDeclaration()||this._parseStylesheetStatement(!0):this._parseStylesheetStatement(!1)}_parseSupportsCondition(){const e=this.create(s.SupportsCondition);if(this.acceptIdent("not"))e.addChild(this._parseSupportsConditionInParens());else if(e.addChild(this._parseSupportsConditionInParens()),this.peekRegExp(r.TokenType.Ident,/^(and|or)$/i)){const t=this.token.text.toLowerCase();for(;this.acceptIdent(t);)e.addChild(this._parseSupportsConditionInParens())}return this.finish(e)}_parseSupportsConditionInParens(){const e=this.create(s.SupportsCondition);if(this.accept(r.TokenType.ParenthesisL))return this.prevToken&&(e.lParent=this.prevToken.offset),e.addChild(this._tryToParseDeclaration([r.TokenType.ParenthesisR]))||this._parseSupportsCondition()?this.accept(r.TokenType.ParenthesisR)?(this.prevToken&&(e.rParent=this.prevToken.offset),this.finish(e)):this.finish(e,i.ParseError.RightParenthesisExpected,[r.TokenType.ParenthesisR],[]):this.finish(e,i.ParseError.ConditionExpected);if(this.peek(r.TokenType.Ident)){const t=this.mark();if(this.consumeToken(),!this.hasWhitespace()&&this.accept(r.TokenType.ParenthesisL)){let t=1;for(;this.token.type!==r.TokenType.EOF&&0!==t;)this.token.type===r.TokenType.ParenthesisL?t++:this.token.type===r.TokenType.ParenthesisR&&t--,this.consumeToken();return this.finish(e)}this.restoreAtMark(t)}return this.finish(e,i.ParseError.LeftParenthesisExpected,[],[r.TokenType.ParenthesisL])}_parseMediaDeclaration(e=!1){return e?this._tryParseRuleset(!0)||this._tryToParseDeclaration()||this._parseStylesheetStatement(!0):this._parseStylesheetStatement(!1)}_parseMedia(e=!1){if(!this.peekKeyword("@media"))return null;const t=this.create(s.Media);return this.consumeToken(),t.addChild(this._parseMediaQueryList())?this._parseBody(t,this._parseMediaDeclaration.bind(this,e)):this.finish(t,i.ParseError.MediaQueryExpected)}_parseMediaQueryList(){const e=this.create(s.Medialist);if(!e.addChild(this._parseMediaQuery()))return this.finish(e,i.ParseError.MediaQueryExpected);for(;this.accept(r.TokenType.Comma);)if(!e.addChild(this._parseMediaQuery()))return this.finish(e,i.ParseError.MediaQueryExpected);return this.finish(e)}_parseMediaQuery(){const e=this.create(s.MediaQuery),t=this.mark();if(this.acceptIdent("not"),this.peek(r.TokenType.ParenthesisL))this.restoreAtMark(t),e.addChild(this._parseMediaCondition());else{if(this.acceptIdent("only"),!e.addChild(this._parseIdent()))return null;this.acceptIdent("and")&&e.addChild(this._parseMediaCondition())}return this.finish(e)}_parseRatio(){const e=this.mark(),t=this.create(s.RatioValue);return this._parseNumeric()?this.acceptDelim("/")?this._parseNumeric()?this.finish(t):this.finish(t,i.ParseError.NumberExpected):(this.restoreAtMark(e),null):null}_parseMediaCondition(){const e=this.create(s.MediaCondition);this.acceptIdent("not");let t=!0;for(;t;){if(!this.accept(r.TokenType.ParenthesisL))return this.finish(e,i.ParseError.LeftParenthesisExpected,[],[r.TokenType.CurlyL]);if(this.peek(r.TokenType.ParenthesisL)||this.peekIdent("not")?e.addChild(this._parseMediaCondition()):e.addChild(this._parseMediaFeature()),!this.accept(r.TokenType.ParenthesisR))return this.finish(e,i.ParseError.RightParenthesisExpected,[],[r.TokenType.CurlyL]);t=this.acceptIdent("and")||this.acceptIdent("or")}return this.finish(e)}_parseMediaFeature(){const e=[r.TokenType.ParenthesisR],t=this.create(s.MediaFeature);if(t.addChild(this._parseMediaFeatureName())){if(this.accept(r.TokenType.Colon)){if(!t.addChild(this._parseMediaFeatureValue()))return this.finish(t,i.ParseError.TermExpected,[],e)}else if(this._parseMediaFeatureRangeOperator()){if(!t.addChild(this._parseMediaFeatureValue()))return this.finish(t,i.ParseError.TermExpected,[],e);if(this._parseMediaFeatureRangeOperator()&&!t.addChild(this._parseMediaFeatureValue()))return this.finish(t,i.ParseError.TermExpected,[],e)}}else{if(!t.addChild(this._parseMediaFeatureValue()))return this.finish(t,i.ParseError.IdentifierExpected,[],e);if(!this._parseMediaFeatureRangeOperator())return this.finish(t,i.ParseError.OperatorExpected,[],e);if(!t.addChild(this._parseMediaFeatureName()))return this.finish(t,i.ParseError.IdentifierExpected,[],e);if(this._parseMediaFeatureRangeOperator()&&!t.addChild(this._parseMediaFeatureValue()))return this.finish(t,i.ParseError.TermExpected,[],e)}return this.finish(t)}_parseMediaFeatureRangeOperator(){return this.acceptDelim("<")||this.acceptDelim(">")?(this.hasWhitespace()||this.acceptDelim("="),!0):!!this.acceptDelim("=")}_parseMediaFeatureName(){return this._parseIdent()}_parseMediaFeatureValue(){return this._parseRatio()||this._parseTermExpression()}_parseMedium(){const e=this.create(s.Node);return e.addChild(this._parseIdent())?this.finish(e):null}_parsePageDeclaration(){return this._parsePageMarginBox()||this._parseRuleSetDeclaration()}_parsePage(){if(!this.peekKeyword("@page"))return null;const e=this.create(s.Page);if(this.consumeToken(),e.addChild(this._parsePageSelector()))for(;this.accept(r.TokenType.Comma);)if(!e.addChild(this._parsePageSelector()))return this.finish(e,i.ParseError.IdentifierExpected);return this._parseBody(e,this._parsePageDeclaration.bind(this))}_parsePageMarginBox(){if(!this.peek(r.TokenType.AtKeyword))return null;const e=this.create(s.PageBoxMarginBox);return this.acceptOneKeyword(n.pageBoxDirectives)||this.markError(e,i.ParseError.UnknownAtRule,[],[r.TokenType.CurlyL]),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))}_parsePageSelector(){if(!this.peek(r.TokenType.Ident)&&!this.peek(r.TokenType.Colon))return null;const e=this.create(s.Node);return e.addChild(this._parseIdent()),this.accept(r.TokenType.Colon)&&!e.addChild(this._parseIdent())?this.finish(e,i.ParseError.IdentifierExpected):this.finish(e)}_parseDocument(){if(!this.peekKeyword("@-moz-document"))return null;const e=this.create(s.Document);return this.consumeToken(),this.resync([],[r.TokenType.CurlyL]),this._parseBody(e,this._parseStylesheetStatement.bind(this))}_parseContainerDeclaration(e=!1){return e?this._tryParseRuleset(!0)||this._tryToParseDeclaration()||this._parseStylesheetStatement(!0):this._parseStylesheetStatement(!1)}_parseContainer(e=!1){if(!this.peekKeyword("@container"))return null;const t=this.create(s.Container);return this.consumeToken(),t.addChild(this._parseIdent()),t.addChild(this._parseContainerQuery()),this._parseBody(t,this._parseContainerDeclaration.bind(this,e))}_parseContainerQuery(){const e=this.create(s.Node);if(this.acceptIdent("not"))e.addChild(this._parseContainerQueryInParens());else if(e.addChild(this._parseContainerQueryInParens()),this.peekIdent("and"))for(;this.acceptIdent("and");)e.addChild(this._parseContainerQueryInParens());else if(this.peekIdent("or"))for(;this.acceptIdent("or");)e.addChild(this._parseContainerQueryInParens());return this.finish(e)}_parseContainerQueryInParens(){const e=this.create(s.Node);if(this.accept(r.TokenType.ParenthesisL)){if(this.peekIdent("not")||this.peek(r.TokenType.ParenthesisL)?e.addChild(this._parseContainerQuery()):e.addChild(this._parseMediaFeature()),!this.accept(r.TokenType.ParenthesisR))return this.finish(e,i.ParseError.RightParenthesisExpected,[],[r.TokenType.CurlyL])}else{if(!this.acceptIdent("style"))return this.finish(e,i.ParseError.LeftParenthesisExpected,[],[r.TokenType.CurlyL]);if(this.hasWhitespace()||!this.accept(r.TokenType.ParenthesisL))return this.finish(e,i.ParseError.LeftParenthesisExpected,[],[r.TokenType.CurlyL]);if(e.addChild(this._parseStyleQuery()),!this.accept(r.TokenType.ParenthesisR))return this.finish(e,i.ParseError.RightParenthesisExpected,[],[r.TokenType.CurlyL])}return this.finish(e)}_parseStyleQuery(){const e=this.create(s.Node);if(this.acceptIdent("not"))e.addChild(this._parseStyleInParens());else if(this.peek(r.TokenType.ParenthesisL)){if(e.addChild(this._parseStyleInParens()),this.peekIdent("and"))for(;this.acceptIdent("and");)e.addChild(this._parseStyleInParens());else if(this.peekIdent("or"))for(;this.acceptIdent("or");)e.addChild(this._parseStyleInParens())}else e.addChild(this._parseDeclaration([r.TokenType.ParenthesisR]));return this.finish(e)}_parseStyleInParens(){const e=this.create(s.Node);return this.accept(r.TokenType.ParenthesisL)?(e.addChild(this._parseStyleQuery()),this.accept(r.TokenType.ParenthesisR)?this.finish(e):this.finish(e,i.ParseError.RightParenthesisExpected,[],[r.TokenType.CurlyL])):this.finish(e,i.ParseError.LeftParenthesisExpected,[],[r.TokenType.CurlyL])}_parseUnknownAtRule(){if(!this.peek(r.TokenType.AtKeyword))return null;const e=this.create(s.UnknownAtRule);e.addChild(this._parseUnknownAtRuleName());let t=0,n=0,a=0,o=0;e:for(;;){switch(this.token.type){case r.TokenType.SemiColon:if(0===n&&0===a&&0===o)break e;break;case r.TokenType.EOF:return n>0?this.finish(e,i.ParseError.RightCurlyExpected):o>0?this.finish(e,i.ParseError.RightSquareBracketExpected):a>0?this.finish(e,i.ParseError.RightParenthesisExpected):this.finish(e);case r.TokenType.CurlyL:t++,n++;break;case r.TokenType.CurlyR:if(n--,t>0&&0===n){if(this.consumeToken(),o>0)return this.finish(e,i.ParseError.RightSquareBracketExpected);if(a>0)return this.finish(e,i.ParseError.RightParenthesisExpected);break e}if(n<0){if(0===a&&0===o)break e;return this.finish(e,i.ParseError.LeftCurlyExpected)}break;case r.TokenType.ParenthesisL:a++;break;case r.TokenType.ParenthesisR:if(a--,a<0)return this.finish(e,i.ParseError.LeftParenthesisExpected);break;case r.TokenType.BracketL:o++;break;case r.TokenType.BracketR:if(o--,o<0)return this.finish(e,i.ParseError.LeftSquareBracketExpected)}this.consumeToken()}return e}_parseUnknownAtRuleName(){const e=this.create(s.Node);return this.accept(r.TokenType.AtKeyword)?this.finish(e):e}_parseOperator(){if(this.peekDelim("/")||this.peekDelim("*")||this.peekDelim("+")||this.peekDelim("-")||this.peek(r.TokenType.Dashmatch)||this.peek(r.TokenType.Includes)||this.peek(r.TokenType.SubstringOperator)||this.peek(r.TokenType.PrefixOperator)||this.peek(r.TokenType.SuffixOperator)||this.peekDelim("=")){const e=this.createNode(s.NodeType.Operator);return this.consumeToken(),this.finish(e)}return null}_parseUnaryOperator(){if(!this.peekDelim("+")&&!this.peekDelim("-"))return null;const e=this.create(s.Node);return this.consumeToken(),this.finish(e)}_parseCombinator(){if(this.peekDelim(">")){const e=this.create(s.Node);this.consumeToken();const t=this.mark();if(!this.hasWhitespace()&&this.acceptDelim(">")){if(!this.hasWhitespace()&&this.acceptDelim(">"))return e.type=s.NodeType.SelectorCombinatorShadowPiercingDescendant,this.finish(e);this.restoreAtMark(t)}return e.type=s.NodeType.SelectorCombinatorParent,this.finish(e)}if(this.peekDelim("+")){const e=this.create(s.Node);return this.consumeToken(),e.type=s.NodeType.SelectorCombinatorSibling,this.finish(e)}if(this.peekDelim("~")){const e=this.create(s.Node);return this.consumeToken(),e.type=s.NodeType.SelectorCombinatorAllSiblings,this.finish(e)}if(this.peekDelim("/")){const e=this.create(s.Node);this.consumeToken();const t=this.mark();if(!this.hasWhitespace()&&this.acceptIdent("deep")&&!this.hasWhitespace()&&this.acceptDelim("/"))return e.type=s.NodeType.SelectorCombinatorShadowPiercingDescendant,this.finish(e);this.restoreAtMark(t)}return null}_parseSimpleSelector(){const e=this.create(s.SimpleSelector);let t=0;for(e.addChild(this._parseElementName()||this._parseNestingSelector())&&t++;(0===t||!this.hasWhitespace())&&e.addChild(this._parseSimpleSelectorBody());)t++;return t>0?this.finish(e):null}_parseNestingSelector(){if(this.peekDelim("&")){const e=this.createNode(s.NodeType.SelectorCombinator);return this.consumeToken(),this.finish(e)}return null}_parseSimpleSelectorBody(){return this._parsePseudo()||this._parseHash()||this._parseClass()||this._parseAttrib()}_parseSelectorIdent(){return this._parseIdent()}_parseHash(){if(!this.peek(r.TokenType.Hash)&&!this.peekDelim("#"))return null;const e=this.createNode(s.NodeType.IdentifierSelector);if(this.acceptDelim("#")){if(this.hasWhitespace()||!e.addChild(this._parseSelectorIdent()))return this.finish(e,i.ParseError.IdentifierExpected)}else this.consumeToken();return this.finish(e)}_parseClass(){if(!this.peekDelim("."))return null;const e=this.createNode(s.NodeType.ClassSelector);return this.consumeToken(),this.hasWhitespace()||!e.addChild(this._parseSelectorIdent())?this.finish(e,i.ParseError.IdentifierExpected):this.finish(e)}_parseElementName(){const e=this.mark(),t=this.createNode(s.NodeType.ElementNameSelector);return t.addChild(this._parseNamespacePrefix()),t.addChild(this._parseSelectorIdent())||this.acceptDelim("*")?this.finish(t):(this.restoreAtMark(e),null)}_parseNamespacePrefix(){const e=this.mark(),t=this.createNode(s.NodeType.NamespacePrefix);return!t.addChild(this._parseIdent())&&this.acceptDelim("*"),this.acceptDelim("|")?this.finish(t):(this.restoreAtMark(e),null)}_parseAttrib(){if(!this.peek(r.TokenType.BracketL))return null;const e=this.create(s.AttributeSelector);return this.consumeToken(),e.setNamespacePrefix(this._parseNamespacePrefix()),e.setIdentifier(this._parseIdent())?(e.setOperator(this._parseOperator())&&(e.setValue(this._parseBinaryExpr()),this.acceptIdent("i"),this.acceptIdent("s")),this.accept(r.TokenType.BracketR)?this.finish(e):this.finish(e,i.ParseError.RightSquareBracketExpected)):this.finish(e,i.ParseError.IdentifierExpected)}_parsePseudo(){const e=this._tryParsePseudoIdentifier();if(e){if(!this.hasWhitespace()&&this.accept(r.TokenType.ParenthesisL)){const t=()=>{const e=this.createNode(s.NodeType.SelectorList);if(!e.addChild(this._parseSelector(!0)))return null;for(;this.accept(r.TokenType.Comma)&&e.addChild(this._parseSelector(!0)););return this.peek(r.TokenType.ParenthesisR)?this.finish(e):null};if(!e.addChild(this.try(t))){for(;!this.peekIdent("of")&&(e.addChild(this._parseTerm())||e.addChild(this._parseOperator())););if(this.acceptIdent("of")&&!e.addChild(this.try(t)))return this.finish(e,i.ParseError.SelectorExpected)}if(!this.accept(r.TokenType.ParenthesisR))return this.finish(e,i.ParseError.RightParenthesisExpected)}return this.finish(e)}return null}_tryParsePseudoIdentifier(){if(!this.peek(r.TokenType.Colon))return null;const e=this.mark(),t=this.createNode(s.NodeType.PseudoSelector);return this.consumeToken(),this.hasWhitespace()?(this.restoreAtMark(e),null):(this.accept(r.TokenType.Colon),this.hasWhitespace()||!t.addChild(this._parseIdent())?this.finish(t,i.ParseError.IdentifierExpected):this.finish(t))}_tryParsePrio(){const e=this.mark(),t=this._parsePrio();return t||(this.restoreAtMark(e),null)}_parsePrio(){if(!this.peek(r.TokenType.Exclamation))return null;const e=this.createNode(s.NodeType.Prio);return this.accept(r.TokenType.Exclamation)&&this.acceptIdent("important")?this.finish(e):null}_parseExpr(e=!1){const t=this.create(s.Expression);if(!t.addChild(this._parseBinaryExpr()))return null;for(;;){if(this.peek(r.TokenType.Comma)){if(e)return this.finish(t);this.consumeToken()}if(!t.addChild(this._parseBinaryExpr()))break}return this.finish(t)}_parseUnicodeRange(){if(!this.peekIdent("u"))return null;const e=this.create(s.UnicodeRange);return this.acceptUnicodeRange()?this.finish(e):null}_parseNamedLine(){if(!this.peek(r.TokenType.BracketL))return null;const e=this.createNode(s.NodeType.GridLine);for(this.consumeToken();e.addChild(this._parseIdent()););return this.accept(r.TokenType.BracketR)?this.finish(e):this.finish(e,i.ParseError.RightSquareBracketExpected)}_parseBinaryExpr(e,t){let r=this.create(s.BinaryExpression);if(!r.setLeft(e||this._parseTerm()))return null;if(!r.setOperator(t||this._parseOperator()))return this.finish(r);if(!r.setRight(this._parseTerm()))return this.finish(r,i.ParseError.TermExpected);r=this.finish(r);const n=this._parseOperator();return n&&(r=this._parseBinaryExpr(r,n)),this.finish(r)}_parseTerm(){let e=this.create(s.Term);return e.setOperator(this._parseUnaryOperator()),e.setExpression(this._parseTermExpression())?this.finish(e):null}_parseTermExpression(){return this._parseURILiteral()||this._parseUnicodeRange()||this._parseFunction()||this._parseIdent()||this._parseStringLiteral()||this._parseNumeric()||this._parseHexColor()||this._parseOperation()||this._parseNamedLine()}_parseOperation(){if(!this.peek(r.TokenType.ParenthesisL))return null;const e=this.create(s.Node);return this.consumeToken(),e.addChild(this._parseExpr()),this.accept(r.TokenType.ParenthesisR)?this.finish(e):this.finish(e,i.ParseError.RightParenthesisExpected)}_parseNumeric(){if(this.peek(r.TokenType.Num)||this.peek(r.TokenType.Percentage)||this.peek(r.TokenType.Resolution)||this.peek(r.TokenType.Length)||this.peek(r.TokenType.EMS)||this.peek(r.TokenType.EXS)||this.peek(r.TokenType.Angle)||this.peek(r.TokenType.Time)||this.peek(r.TokenType.Dimension)||this.peek(r.TokenType.ContainerQueryLength)||this.peek(r.TokenType.Freq)){const e=this.create(s.NumericValue);return this.consumeToken(),this.finish(e)}return null}_parseStringLiteral(){if(!this.peek(r.TokenType.String)&&!this.peek(r.TokenType.BadString))return null;const e=this.createNode(s.NodeType.StringLiteral);return this.consumeToken(),this.finish(e)}_parseURILiteral(){if(!this.peekRegExp(r.TokenType.Ident,/^url(-prefix)?$/i))return null;const e=this.mark(),t=this.createNode(s.NodeType.URILiteral);return this.accept(r.TokenType.Ident),this.hasWhitespace()||!this.peek(r.TokenType.ParenthesisL)?(this.restoreAtMark(e),null):(this.scanner.inURL=!0,this.consumeToken(),t.addChild(this._parseURLArgument()),this.scanner.inURL=!1,this.accept(r.TokenType.ParenthesisR)?this.finish(t):this.finish(t,i.ParseError.RightParenthesisExpected))}_parseURLArgument(){const e=this.create(s.Node);return this.accept(r.TokenType.String)||this.accept(r.TokenType.BadString)||this.acceptUnquotedString()?this.finish(e):null}_parseIdent(e){if(!this.peek(r.TokenType.Ident))return null;const t=this.create(s.Identifier);return e&&(t.referenceTypes=e),t.isCustomProperty=this.peekRegExp(r.TokenType.Ident,/^--/),this.consumeToken(),this.finish(t)}_parseFunction(){const e=this.mark(),t=this.create(s.Function);if(!t.setIdentifier(this._parseFunctionIdentifier()))return null;if(this.hasWhitespace()||!this.accept(r.TokenType.ParenthesisL))return this.restoreAtMark(e),null;if(t.getArguments().addChild(this._parseFunctionArgument()))for(;this.accept(r.TokenType.Comma)&&!this.peek(r.TokenType.ParenthesisR);)t.getArguments().addChild(this._parseFunctionArgument())||this.markError(t,i.ParseError.ExpressionExpected);return this.accept(r.TokenType.ParenthesisR)?this.finish(t):this.finish(t,i.ParseError.RightParenthesisExpected)}_parseFunctionIdentifier(){if(!this.peek(r.TokenType.Ident))return null;const e=this.create(s.Identifier);if(e.referenceTypes=[s.ReferenceType.Function],this.acceptIdent("progid")){if(this.accept(r.TokenType.Colon))for(;this.accept(r.TokenType.Ident)&&this.acceptDelim("."););return this.finish(e)}return this.consumeToken(),this.finish(e)}_parseFunctionArgument(){const e=this.create(s.FunctionArgument);return e.setValue(this._parseExpr(!0))?this.finish(e):null}_parseHexColor(){if(this.peekRegExp(r.TokenType.Hash,/^#([A-Fa-f0-9]{3}|[A-Fa-f0-9]{4}|[A-Fa-f0-9]{6}|[A-Fa-f0-9]{8})$/g)){const e=this.create(s.HexColorValue);return this.consumeToken(),this.finish(e)}return null}}}));